Loading...
Searching...
No Matches
juce::ResizableWindow Class Reference

## Detailed Description

A base class for top-level windows that can be dragged around and resized.

To add content to the window, use its setContentOwned() or setContentNonOwned() methods to give it a component that will remain positioned inside it (leaving a gap around the edges for a border).

It's not advisable to add child components directly to a ResizableWindow: put them inside your content component instead. And overriding methods like resized(), moved(), etc is also not recommended - instead override these methods for your content component. (If for some obscure reason you do need to override these methods, always remember to call the super-class's resized() method too, otherwise it'll fail to lay out the window decorations correctly).

By default resizing isn't enabled - use the setResizable() method to enable it and to choose the style of resizing to use.

See also
  TopLevelWindow

The documentation for this class was generated from the following file:

- juce_gui_basics/windows/juce_ResizableWindow.h

Inheritance diagram for juce::ResizableWindow:

## Classes

struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide window drawing functionality. More...

## Public Types

enum | ColourIds { backgroundColourId = 0x1005700 }
| A set of colour IDs to use to change the colour of various aspects of the window. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| ResizableWindow (const String &name, bool addToDesktop)
| Creates a ResizableWindow.
| ResizableWindow (const String &name, Colour backgroundColour, bool addToDesktop)
| Creates a ResizableWindow.
| ~ResizableWindow () override
| Destructor.
Colour | getBackgroundColour () const noexcept
| Returns the colour currently being used for the window's background.
void | setBackgroundColour (Colour newColour)
| Changes the colour currently being used for the window's background.
void | setResizable (bool shouldBeResizable, bool useBottomRightCornerResizer)
| Make the window resizable or fixed.
bool | isResizable () const noexcept
| Returns true if resizing is enabled.
void | setResizeLimits (int newMinimumWidth, int newMinimumHeight, int newMaximumWidth, int newMaximumHeight) noexcept
| This sets the maximum and minimum sizes for the window.
void | setDraggable (bool shouldBeDraggable) noexcept
| Can be used to enable or disable user-dragging of the window.
bool | isDraggable () const noexcept
| Returns true if the window can be dragged around by the user.
ComponentBoundsConstrainer * | getConstrainer () noexcept
| Returns the bounds constrainer object that this window is using.
void | setConstrainer (ComponentBoundsConstrainer *newConstrainer)
| Sets the bounds-constrainer object to use for resizing and dragging this window.
void | setBoundsConstrained (const Rectangle< int > &newBounds)
| Calls the window's setBounds method, after first checking these bounds with the current constrainer.
bool | isFullScreen () const
| Returns true if the window is currently in full-screen mode.
void | setFullScreen (bool shouldBeFullScreen)
| Puts the window into full-screen mode, or restores it to its normal size.
bool | isMinimised () const
| Returns true if the window is currently minimised.
void | setMinimised (bool shouldMinimise)
| Minimises the window, or restores it to its previous position and size.
bool | isKioskMode () const
| Returns true if the window has been placed in kiosk-mode.
String | getWindowStateAsString ()
| Returns a string which encodes the window's current size and position.
bool | restoreWindowStateFromString (const String &previousState)
| Restores the window to a previously-saved size and position.
Component * | getContentComponent () const noexcept
| Returns the current content component.
void | setContentOwned (Component *newContentComponent, bool resizeToFitWhenContentChangesSize)
| Changes the current content component.
void | setContentNonOwned (Component *newContentComponent, bool resizeToFitWhenContentChangesSize)
| Changes the current content component.
void | clearContentComponent ()
| Removes the current content component.
void | setContentComponentSize (int width, int height)
| Changes the window so that the content component ends up with the specified size.
virtual BorderSize< int > | getBorderThickness () const
| Returns the width of the frame to use around the window.
virtual BorderSize< int > | getContentComponentBorder () const
| Returns the insets to use when positioning the content component.
void | addToDesktop ()
| Adds the window to the desktop using the default flags.
void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr) override
| Makes this component appear as a window on the desktop.
Public Member Functions inherited from juce::TopLevelWindow
| TopLevelWindow (const String &name, bool addToDesktop)
| Creates a TopLevelWindow.
| ~TopLevelWindow () override
| Destructor.
bool | isActiveWindow () const noexcept
| True if this is currently the TopLevelWindow that is actively being used.
void | centreAroundComponent (Component *componentToCentreAround, int width, int height)
| This will set the bounds of the window so that it's centred in front of another window.
void | setDropShadowEnabled (bool useShadow)
| Turns the drop-shadow on and off.
bool | isDropShadowEnabled () const noexcept
| True if drop-shadowing is enabled.
void | setUsingNativeTitleBar (bool useNativeTitleBar)
| Sets whether an OS-native title bar will be used, or a JUCE one.
bool | isUsingNativeTitleBar () const noexcept
| Returns true if the window is currently using an OS-native title bar.
void | addToDesktop ()
| Adds the window to the desktop using the default flags.
void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr) override
| Makes this component appear as a window on the desktop.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.

## Protected Member Functions

void | paint (Graphics &) override
| Components can override this method to draw their content.
void | moved () override
| (if overriding this, make sure you call ResizableWindow::moved() in your subclass)
void | resized () override
| (if overriding this, make sure you call ResizableWindow::resized() in your subclass)
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
void | childBoundsChanged (Component *) override
| Called when one of this component's children is moved or resized.
void | parentSizeChanged () override
| Called when this component's immediate parent has been resized.
void | visibilityChanged () override
| Called when this component's visibility changes.
void | activeWindowStatusChanged () override
| This callback happens when this window becomes active or inactive.
int | getDesktopWindowStyleFlags () const override
void | getBorderThickness (int &left, int &top, int &right, int &bottom)
void | getContentComponentBorder (int &left, int &top, int &right, int &bottom)
Protected Member Functions inherited from juce::TopLevelWindow
void | focusOfChildComponentChanged (FocusChangeType) override
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
void | parentHierarchyChanged () override
| Called to indicate that the component's parents have changed.
void | recreateDesktopWindow ()
void | visibilityChanged () override
| Called when this component's visibility changes.

## Protected Attributes

std::unique_ptr< ResizableCornerComponent > | resizableCorner
std::unique_ptr< ResizableBorderComponent > | resizableBorder

## Additional Inherited Members

Static Public Member Functions inherited from juce::TopLevelWindow
static int | getNumTopLevelWindows () noexcept
| Returns the number of TopLevelWindow objects currently in use.
static TopLevelWindow * | getTopLevelWindow (int index) noexcept
| Returns one of the TopLevelWindow objects currently in use.
static TopLevelWindow * | getActiveTopLevelWindow () noexcept
| Returns the currently-active top level window.
Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Member Enums

## ColourIds

enum juce::ResizableWindow::ColourIds

A set of colour IDs to use to change the colour of various aspects of the window.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A colour to use to fill the window's background.

## Constructors and Destructors

## ResizableWindow() [1/2]

juce::ResizableWindow::ResizableWindow | ( | const String & | name,
|  | bool | addToDesktop )

Creates a ResizableWindow.

This constructor doesn't specify a background colour, so the LookAndFeel's default background colour will be used.

Parameters

  name | the name to give the component
  addToDesktop | if true, the window will be automatically added to the desktop; if false, you can use it as a child component

References addToDesktop(), and name.

Referenced by juce::ResizableWindow::LookAndFeelMethods::drawResizableWindowBorder(), juce::ResizableWindow::LookAndFeelMethods::fillResizableWindowBackground(), and getContentComponentBorder().

## ResizableWindow() [2/2]

juce::ResizableWindow::ResizableWindow | ( | const String & | name,
|  | Colour | backgroundColour,
|  | bool | addToDesktop )

Creates a ResizableWindow.

Parameters

  name | the name to give the component
  backgroundColour | the colour to use for filling the window's background.
  addToDesktop | if true, the window will be automatically added to the desktop; if false, you can use it as a child component

References addToDesktop(), and name.

## ~ResizableWindow()

juce::ResizableWindow::~ResizableWindow | ( |  | ) |

override

Destructor.

If a content component has been set with setContentOwned(), it will be deleted.

## Member Functions

## getBackgroundColour()

Colour juce::ResizableWindow::getBackgroundColour | ( |  | ) | const

noexcept

Returns the colour currently being used for the window's background.

As a convenience the window will fill itself with this colour, but you can override the paint() method if you need more customised behaviour.

This method is the same as retrieving the colour for ResizableWindow::backgroundColourId.

See also
  setBackgroundColour

## setBackgroundColour()

void juce::ResizableWindow::setBackgroundColour | ( | Colour | newColour | ) |

Changes the colour currently being used for the window's background.

As a convenience the window will fill itself with this colour, but you can override the paint() method if you need more customised behaviour.

Note that the opaque state of this window is altered by this call to reflect the opacity of the colour passed-in. On window systems which can't support semi-transparent windows this might cause problems, (though it's unlikely you'll be using this class as a base for a semi-transparent component anyway).

You can also use the ResizableWindow::backgroundColourId colour id to set this colour.

See also
  getBackgroundColour

References setBackgroundColour().

Referenced by setBackgroundColour().

## setResizable()

void juce::ResizableWindow::setResizable | ( | bool | shouldBeResizable,
|  | bool | useBottomRightCornerResizer )

Make the window resizable or fixed.

Parameters

  shouldBeResizable | whether it's resizable at all
  useBottomRightCornerResizer | if true, it'll add a ResizableCornerComponent at the bottom-right; if false, it'll use a ResizableBorderComponent around the edge

See also
  setResizeLimits, isResizable

References setResizable().

Referenced by setResizable(), and juce::StandaloneFilterWindow::StandaloneFilterWindow().

## isResizable()

bool juce::ResizableWindow::isResizable | ( |  | ) | const

noexcept

Returns true if resizing is enabled.

See also
  setResizable

References isResizable().

Referenced by isResizable().

## setResizeLimits()

void juce::ResizableWindow::setResizeLimits | ( | int | newMinimumWidth,
|  | int | newMinimumHeight,
|  | int | newMaximumWidth,
|  | int | newMaximumHeight )

noexcept

This sets the maximum and minimum sizes for the window.

If the window's current size is outside these limits, it will be resized to make sure it's within them.

A direct call to setBounds() will bypass any constraint checks, but when the window is dragged by the user or resized by other indirect means, the constrainer will limit the numbers involved.

See also
  setResizable, setFixedAspectRatio

References setResizeLimits().

Referenced by setResizeLimits().

## setDraggable()

void juce::ResizableWindow::setDraggable | ( | bool | shouldBeDraggable | ) |

noexcept

Can be used to enable or disable user-dragging of the window.

References setDraggable().

Referenced by setDraggable().

## isDraggable()

bool juce::ResizableWindow::isDraggable | ( |  | ) | const

inline noexcept

Returns true if the window can be dragged around by the user.

References isDraggable().

Referenced by isDraggable().

## getConstrainer()

ComponentBoundsConstrainer * juce::ResizableWindow::getConstrainer | ( |  | ) |

inline noexcept

Returns the bounds constrainer object that this window is using.

You can access this to change its properties.

## setConstrainer()

void juce::ResizableWindow::setConstrainer | ( | ComponentBoundsConstrainer * | newConstrainer | ) |

Sets the bounds-constrainer object to use for resizing and dragging this window.

A pointer to the object you pass in will be kept, but it won't be deleted by this object, so it's the caller's responsibility to manage it.

If you pass a nullptr, then no constraints will be placed on the positioning of the window.

Referenced by juce::StandaloneFilterWindow::StandaloneFilterWindow().

## setBoundsConstrained()

void juce::ResizableWindow::setBoundsConstrained | ( | const Rectangle< int > & | newBounds | ) |

Calls the window's setBounds method, after first checking these bounds with the current constrainer.

See also
  setConstrainer

Referenced by juce::StandaloneFilterWindow::StandaloneFilterWindow().

## isFullScreen()

bool juce::ResizableWindow::isFullScreen | ( |  | ) | const

Returns true if the window is currently in full-screen mode.

See also
  setFullScreen

## setFullScreen()

void juce::ResizableWindow::setFullScreen | ( | bool | shouldBeFullScreen | ) |

Puts the window into full-screen mode, or restores it to its normal size.

If true, the window will become full-screen; if false, it will return to the last size it was before being made full-screen.

See also
  isFullScreen

Referenced by juce::StandaloneFilterWindow::StandaloneFilterWindow().

## isMinimised()

bool juce::ResizableWindow::isMinimised | ( |  | ) | const

Returns true if the window is currently minimised.

See also
  setMinimised

## setMinimised()

void juce::ResizableWindow::setMinimised | ( | bool | shouldMinimise | ) |

Minimises the window, or restores it to its previous position and size.

When being un-minimised, it'll return to the last position and size it was in before being minimised.

See also
  isMinimised

## isKioskMode()

bool juce::ResizableWindow::isKioskMode | ( |  | ) | const

Returns true if the window has been placed in kiosk-mode.

See also
  Desktop::setKioskComponent

## getWindowStateAsString()

String juce::ResizableWindow::getWindowStateAsString | ( |  | ) |

Returns a string which encodes the window's current size and position.

This string will encapsulate the window's size, position, and whether it's in full-screen mode. It's intended for letting your application save and restore a window's position.

Use the restoreWindowStateFromString() to restore from a saved state.

See also
  restoreWindowStateFromString

## restoreWindowStateFromString()

bool juce::ResizableWindow::restoreWindowStateFromString | ( | const String & | previousState | ) |

Restores the window to a previously-saved size and position.

This restores the window's size, position and full-screen status from an string that was previously created with the getWindowStateAsString() method.

Returns
  false if the string wasn't a valid window state

See also
  getWindowStateAsString

## getContentComponent()

Component * juce::ResizableWindow::getContentComponent | ( |  | ) | const

inline noexcept

Returns the current content component.

This will be the component set by setContentOwned() or setContentNonOwned, or nullptr if none has yet been specified.

See also
  setContentOwned, setContentNonOwned

## setContentOwned()

void juce::ResizableWindow::setContentOwned | ( | Component * | newContentComponent,
|  | bool | resizeToFitWhenContentChangesSize )

Changes the current content component.

This sets a component that will be placed in the centre of the ResizableWindow, (leaving a space around the edge for the border).

You should never add components directly to a ResizableWindow (or any of its subclasses) with addChildComponent(). Instead, add them to the content component.

Parameters

  newContentComponent | the new component to use - this component will be deleted when it's no longer needed (i.e. when the window is deleted or a new content component is set for it). To set a component that this window will not delete, call setContentNonOwned() instead.
  resizeToFitWhenContentChangesSize | if true, then the ResizableWindow will maintain its size such that it always fits around the size of the content component. If false, the new content will be resized to fit the current space available.

## setContentNonOwned()

void juce::ResizableWindow::setContentNonOwned | ( | Component * | newContentComponent,
|  | bool | resizeToFitWhenContentChangesSize )

Changes the current content component.

This sets a component that will be placed in the centre of the ResizableWindow, (leaving a space around the edge for the border).

You should never add components directly to a ResizableWindow (or any of its subclasses) with addChildComponent(). Instead, add them to the content component.

Parameters

  newContentComponent | the new component to use - this component will NOT be deleted by this component, so it's the caller's responsibility to manage its lifetime (it's ok to delete it while this window is still using it). To set a content component that the window will delete, call setContentOwned() instead.
  resizeToFitWhenContentChangesSize | if true, then the ResizableWindow will maintain its size such that it always fits around the size of the content component. If false, the new content will be resized to fit the current space available.

## clearContentComponent()

void juce::ResizableWindow::clearContentComponent | ( |  | ) |

Removes the current content component.

If the previous content component was added with setContentOwned(), it will also be deleted. If it was added with setContentNonOwned(), it will simply be removed from this component.

Referenced by juce::StandaloneFilterWindow::resetToDefaultState(), and juce::StandaloneFilterWindow::~StandaloneFilterWindow().

## setContentComponentSize()

void juce::ResizableWindow::setContentComponentSize | ( | int | width,
|  | int | height )

Changes the window so that the content component ends up with the specified size.

This is basically a setSize call on the window, but which adds on the borders, so you can specify the content component's target size.

## getBorderThickness() [1/2]

virtual BorderSize< int > juce::ResizableWindow::getBorderThickness | ( |  | ) | const

virtual

Returns the width of the frame to use around the window.

See also
  getContentComponentBorder

## getContentComponentBorder() [1/2]

virtual BorderSize< int > juce::ResizableWindow::getContentComponentBorder | ( |  | ) | const

virtual

Returns the insets to use when positioning the content component.

See also
  getBorderThickness

## paint()

void juce::ResizableWindow::paint | ( | Graphics & | g | ) |

override protected virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## moved()

void juce::ResizableWindow::moved | ( |  | ) |

override protected virtual

(if overriding this, make sure you call ResizableWindow::moved() in your subclass)

Reimplemented from juce::Component.

## resized()

void juce::ResizableWindow::resized | ( |  | ) |

override protected virtual

(if overriding this, make sure you call ResizableWindow::resized() in your subclass)

Reimplemented from juce::Component.

Reimplemented in juce::StandaloneFilterWindow.

## mouseDown()

void juce::ResizableWindow::mouseDown | ( | const MouseEvent & | event | ) |

override protected virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseDrag()

void juce::ResizableWindow::mouseDrag | ( | const MouseEvent & | event | ) |

override protected virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::Component.

## mouseUp()

void juce::ResizableWindow::mouseUp | ( | const MouseEvent & | event | ) |

override protected virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## lookAndFeelChanged()

void juce::ResizableWindow::lookAndFeelChanged | ( |  | ) |

override protected virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## childBoundsChanged()

void juce::ResizableWindow::childBoundsChanged | ( | Component * | child | ) |

override protected virtual

Called when one of this component's children is moved or resized.

If the parent wants to know about changes to its immediate children (not to children of its children), this is the method to override.

See also
  moved, resized, parentSizeChanged

Reimplemented from juce::Component.

## parentSizeChanged()

void juce::ResizableWindow::parentSizeChanged | ( |  | ) |

override protected virtual

Called when this component's immediate parent has been resized.

If the component is a top-level window, this indicates that the screen size has changed.

See also
  childBoundsChanged, moved, resized

Reimplemented from juce::Component.

## visibilityChanged()

void juce::ResizableWindow::visibilityChanged | ( |  | ) |

override protected virtual

Called when this component's visibility changes.

See also
  setVisible, isVisible

Reimplemented from juce::Component.

## activeWindowStatusChanged()

void juce::ResizableWindow::activeWindowStatusChanged | ( |  | ) |

override protected virtual

This callback happens when this window becomes active or inactive.

See also
  isActiveWindow

Reimplemented from juce::TopLevelWindow.

## getDesktopWindowStyleFlags()

int juce::ResizableWindow::getDesktopWindowStyleFlags | ( |  | ) | const

override protected virtual

Reimplemented from juce::TopLevelWindow.

References juce::Component::addAndMakeVisible(), and juce::Component::addChildComponent().

## getBorderThickness() [2/2]

void juce::ResizableWindow::getBorderThickness | ( | int & | left,
|  | int & | top,
|  | int & | right,
|  | int & | bottom )

protected

## getContentComponentBorder() [2/2]

void juce::ResizableWindow::getContentComponentBorder | ( | int & | left,
|  | int & | top,
|  | int & | right,
|  | int & | bottom )

protected

References addToDesktop(), and ResizableWindow().

## addToDesktop() [1/2]

void juce::TopLevelWindow::addToDesktop | ( |  | ) |

Adds the window to the desktop using the default flags.

Referenced by juce::DialogWindow::DialogWindow(), juce::DocumentWindow::DocumentWindow(), getContentComponentBorder(), ResizableWindow(), and ResizableWindow().

## addToDesktop() [2/2]

void juce::TopLevelWindow::addToDesktop | ( | int | windowStyleFlags,
|  | void * | nativeWindowToAttachTo = nullptr )

override virtual

Makes this component appear as a window on the desktop.

Note that before calling this, you should make sure that the component's opacity is set correctly using setOpaque(). If the component is non-opaque, the windowing system will try to create a special transparent window for it, which will generally take a lot more CPU to operate (and might not even be possible on some platforms).

If the component is inside a parent component at the time this method is called, it will first be removed from that parent. Likewise if a component is on the desktop and is subsequently added to another component, it'll be removed from the desktop.

Parameters

  windowStyleFlags | a combination of the flags specified in the ComponentPeer::StyleFlags enum, which define the window's characteristics.
  nativeWindowToAttachTo | this allows an OS object to be passed-in as the window in which the juce component should place itself. On Windows, this would be a HWND, a HIViewRef on the Mac. Not necessarily supported on all platforms, and best left as 0 unless you know what you're doing.

See also
  removeFromDesktop, isOnDesktop, userTriedToCloseWindow, getPeer, ComponentPeer::setMinimised, ComponentPeer::StyleFlags, ComponentPeer::getStyleFlags, ComponentPeer::setFullScreen

Reimplemented from juce::Component.

## Member Data Documentation

## resizableCorner

std::unique_ptr<ResizableCornerComponent> juce::ResizableWindow::resizableCorner

protected

## resizableBorder

std::unique_ptr<ResizableBorderComponent> juce::ResizableWindow::resizableBorder

protected

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited